unit Refs;

interface

uses
{$IFDEF LINUX}
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs, QStdCtrls,
  QDBCtrls, QComCtrls, QExtCtrls, QGrids, QDBGrids, QButtons, OdacClx,
{$ELSE}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, ExtCtrls, Grids, DBGrids, StdCtrls, ComCtrls, ToolWin, Buttons,
  OdacVcl,
{$ENDIF}
  Db, Ora, OraScript, DBAccess, MemDS, OraSmart, OdacDemoFrame, OdacDemoForm,
  DAScript;

type
  TRefsFrame = class(TOdacDemoFrame)
    ToolBar1: TPanel;
    DBGrid: TDBGrid;
    dsData: TDataSource;
    Query: TSmartQuery;
    Panel1: TPanel;
    Splitter1: TSplitter;
    DataSource1: TDataSource;
    OraNestedTableLeft: TOraNestedTable;
    OraNestedTable: TOraNestedTable;
    OraNestedTableRight: TOraNestedTable;
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    DBGrid3: TDBGrid;
    DataSource3: TDataSource;
    QuerySTR: TStringField;
    QueryNUM: TFloatField;
    QueryLEFT: TOraReferenceField;
    QueryRIGHT: TOraReferenceField;
    QueryROWID: TStringField;
    Panel4: TPanel;
    btOpen: TSpeedButton;
    btClose: TSpeedButton;
    DBNavigator1: TDBNavigator;
    Panel5: TPanel;
    cbObjectView: TCheckBox;
    Panel6: TPanel;
    btGetLeft: TSpeedButton;
    btGetRight: TSpeedButton;
    DBNavigator4: TDBNavigator;
    Panel7: TPanel;
    Panel8: TPanel;
    DBNavigator2: TDBNavigator;
    DBNavigator3: TDBNavigator;
    procedure btOpenClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure cbObjectViewClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure btGetLeftClick(Sender: TObject);
    procedure btGetRightClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Initialize; override;
    procedure SetDebug(Value: boolean); override;
  end;

implementation
uses
  OraCall, OraClasses, OraObjects;

{$IFNDEF FPC}
{$IFDEF CLR}
{$R *.nfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}
{$ENDIF}

procedure TRefsFrame.btOpenClick(Sender: TObject);
begin
  dsData.DataSet.Open;
  OraNestedTableLeft.Open;
  OraNestedTableRight.Open;
end;

procedure TRefsFrame.btCloseClick(Sender: TObject);
begin
  OraNestedTableRight.Close;
  OraNestedTableLeft.Close;  
  dsData.DataSet.Close;
end;

procedure TRefsFrame.Initialize;
begin
  inherited;

  Query.Connection := Connection;

  cbObjectView.Checked := dsData.DataSet.ObjectView;
end;

procedure TRefsFrame.cbObjectViewClick(Sender: TObject);
begin
  if not dsData.DataSet.Active then
    dsData.DataSet.ObjectView := cbObjectView.Checked
  else
    cbObjectView.Checked := dsData.DataSet.ObjectView;
end;

procedure TRefsFrame.SetDebug(Value: boolean);
begin
  Query.Debug := Value;
end;

procedure TRefsFrame.SpeedButton1Click(Sender: TObject);
begin
{  OraSQL1.ParamByName('R').AsRef.ObjectType := TOraType(GetOraType(OraSession.OCISvcCtx, 'TRefObjectType'));
  OraSQL1.Execute;
  OraSQL1.ParamByName('R').AsRef.Pin;
  OraNestedTable2.Ref := OraSQL1.ParamByName('R').AsRef;
  OraNestedTable2.Open;}
end;

procedure TRefsFrame.btGetLeftClick(Sender: TObject);
begin
  OraNestedTable.Ref := Query.GetRef('Left');
  OraNestedTable.Open;
end;

procedure TRefsFrame.btGetRightClick(Sender: TObject);
begin
  OraNestedTable.Ref := Query.GetRef('Right');
  OraNestedTable.Open;
end;

end.
